<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'pkid',
    label: '等级编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'levelkey',
    label: '等级',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'levelname',
    label: '等级名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'levelmax',
    label: '最高分',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'levelmin',
    label: '最低分',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'nextDate',
    label: '下次评级日期（天）',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'orderby',
    label: '下轮重评日期（天）',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

